---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for 10 MHz Output Aligner Unit
---------------------------------------------------------------------------------------
-- File           : 10mhz_align_unit_wbgen2_pkg.vhd
-- Author         : auto-generated by wbgen2 from 10mhz_align_unit_wb.wb
-- Created        : Tue Sep 24 11:12:23 2019
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE 10mhz_align_unit_wb.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wishbone_pkg.all;

package tau_wbgen2_pkg is
  
  
  -- Input registers (user design -> WB slave)
  
  type t_tau_in_registers is record
    csr_done_i                               : std_logic;
    csr_offset_i                             : std_logic_vector(11 downto 0);
    csr_pll_locked_i                         : std_logic;
  end record;
  
  constant c_tau_in_registers_init_value: t_tau_in_registers := (
    csr_done_i => '0',
    csr_offset_i => (others => '0'),
    csr_pll_locked_i => '0'
  );
  
  -- Output registers (WB slave -> user design)
  
  type t_tau_out_registers is record
    csr_trig_o                               : std_logic;
    csr_pll_rst_o                            : std_logic;
    idelay_cr_load_o                         : std_logic;
    idelay_cr_taps_o                         : std_logic_vector(4 downto 0);
    dummy_load_o                             : std_logic;
  end record;
  
  constant c_tau_out_registers_init_value: t_tau_out_registers := (
    csr_trig_o => '0',
    csr_pll_rst_o => '0',
    idelay_cr_load_o => '0',
    idelay_cr_taps_o => (others => '0'),
    dummy_load_o => '0'
  );

function "or" (left, right: t_tau_in_registers) return t_tau_in_registers;
function f_x_to_zero (x:std_logic) return std_logic;
function f_x_to_zero (x:std_logic_vector) return std_logic_vector;

component tenmhz_align_unit_wb is
  port (
    rst_n_i                                  : in     std_logic;
    clk_sys_i                                : in     std_logic;
    clk_ref_i                                : in     std_logic;
    slave_i                                  : in     t_wishbone_slave_in;
    slave_o                                  : out    t_wishbone_slave_out;
    int_o                                    : out    std_logic;
    regs_i                                   : in     t_tau_in_registers;
    regs_o                                   : out    t_tau_out_registers
  );
end component;

end package;

package body tau_wbgen2_pkg is
function f_x_to_zero (x:std_logic) return std_logic is
begin
  if x = '1' then
    return '1';
  else
    return '0';
  end if;
end function;

function f_x_to_zero (x:std_logic_vector) return std_logic_vector is
  variable tmp: std_logic_vector(x'length-1 downto 0);
begin
  for i in 0 to x'length-1 loop
    if(x(i) = 'X' or x(i) = 'U') then
      tmp(i):= '0';
    else
      tmp(i):=x(i);
    end if; 
  end loop; 
  return tmp;
end function;

function "or" (left, right: t_tau_in_registers) return t_tau_in_registers is
  variable tmp: t_tau_in_registers;
begin
  tmp.csr_done_i := f_x_to_zero(left.csr_done_i) or f_x_to_zero(right.csr_done_i);
  tmp.csr_offset_i := f_x_to_zero(left.csr_offset_i) or f_x_to_zero(right.csr_offset_i);
  tmp.csr_pll_locked_i := f_x_to_zero(left.csr_pll_locked_i) or f_x_to_zero(right.csr_pll_locked_i);
  return tmp;
end function;

end package body;
